Skip to main content
`Ctrl`+`K`

# scipy.stats.ortho_group

scipy.stats.ortho_group = <scipy.stats._multivariate.ortho_group_gen object>

  An Orthogonal matrix (O(N)) random variable.

  Return a random orthogonal matrix, drawn from the O(N) Haar distribution (the only uniform distribution on O(N)).

  The dim keyword specifies the dimension N.

  Parameters:
    dim scalar

      Dimension of matrices

    seed{None, int, np.random.RandomState, np.random.Generator}, optional

      Used for drawing random variates. If seed is None, the RandomState singleton is used. If seed is an int, a new `RandomState` instance is used, seeded with seed. If seed is already a `RandomState` or `Generator` instance, then that object is used. Default is None.

  Methods

  rvs(dim=None, size=1, random_state=None) | Draw random samples from O(N).

  See also

  `special_ortho_group`

  Notes

  This class is closely related to `special_ortho_group`.

  Some care is taken to avoid numerical error, as per the paper by Mezzadri.

  References

  [1]

  F. Mezzadri, “How to generate random matrices from the classical compact groups”, arXiv:math-ph/0609050v2.

  Examples

      >>> import numpy as np
      >>> from scipy.stats import ortho_group
      >>> x = ortho_group.rvs(3)

      >>> np.dot(x, x.T)
      array([[  1.00000000e+00,   1.13231364e-17,  -2.86852790e-16],
             [  1.13231364e-17,   1.00000000e+00,  -1.46845020e-16],
             [ -2.86852790e-16,  -1.46845020e-16,   1.00000000e+00]])

      >>> import scipy.linalg
      >>> np.fabs(scipy.linalg.det(x))
      1.0

  This generates one random matrix from O(3). It is orthogonal and has a determinant of +1 or -1.

  Alternatively, the object may be called (as a function) to fix the dim parameter, returning a “frozen” ortho_group random variable:

      >>> rv = ortho_group(5)
      >>> # Frozen object with the same methods but holding the
      >>> # dimension parameter fixed.